// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "outlooksample.h"
#include "DlgProxy.h"
#include "outlooksampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COutlooksampleDlgAutoProxy

IMPLEMENT_DYNCREATE(COutlooksampleDlgAutoProxy, CCmdTarget)

COutlooksampleDlgAutoProxy::COutlooksampleDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(COutlooksampleDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (COutlooksampleDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

COutlooksampleDlgAutoProxy::~COutlooksampleDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void COutlooksampleDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(COutlooksampleDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(COutlooksampleDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(COutlooksampleDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(COutlooksampleDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IOutlooksample to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {64FB66C8-DD1C-44CE-BE77-8395EA2A441E}
static const IID IID_IOutlooksample =
{ 0x64fb66c8, 0xdd1c, 0x44ce, { 0xbe, 0x77, 0x83, 0x95, 0xea, 0x2a, 0x44, 0x1e } };

BEGIN_INTERFACE_MAP(COutlooksampleDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(COutlooksampleDlgAutoProxy, IID_IOutlooksample, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {29F81ACE-36C8-45B8-9AE7-4DEFA414F248}
IMPLEMENT_OLECREATE2(COutlooksampleDlgAutoProxy, "Outlooksample.Application", 0x29f81ace, 0x36c8, 0x45b8, 0x9a, 0xe7, 0x4d, 0xef, 0xa4, 0x14, 0xf2, 0x48)

/////////////////////////////////////////////////////////////////////////////
// COutlooksampleDlgAutoProxy message handlers
