// EventSink.cpp : implementation file
//

#include "stdafx.h"
#include "outlooksample.h"
#include "EventSink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEventSink

//IMPLEMENT_DYNCREATE(CEventSink, CCmdTarget)

CEventSink::CEventSink(COutlooksampleDlg& dlg,IDispatch *disp) : m_dlg(dlg),
		m_inspector(disp),m_explorer(disp)
{
	EnableConnections();
	EnableAutomation();

	if(m_inspector != 0) {
		m_dwCokkie = Advice(disp,GetIDispatch(FALSE),__uuidof(Outlook::InspectorEvents));
	}
	else {
		m_dwCokkie = Advice(disp,GetIDispatch(FALSE),__uuidof(Outlook::ExplorerEvents));
	}
}

CEventSink::~CEventSink()
{
}


BEGIN_MESSAGE_MAP(CEventSink, CCmdTarget)
	//{{AFX_MSG_MAP(CEventSink)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventSink message handlers


BEGIN_DISPATCH_MAP(CEventSink, CCmdTarget)
	DISP_FUNCTION_ID(CEventSink, "Activate",0x0000f001,Activate,VT_EMPTY,VTS_NONE)
	DISP_FUNCTION_ID(CEventSink, "Deactivate",0x0000f006,Deactivate,VT_EMPTY,VTS_NONE)
	DISP_FUNCTION_ID(CEventSink, "Close",0x0000f008,Close,VT_EMPTY,VTS_NONE)

	DISP_FUNCTION_ID(CEventSink, "SelectionChange",0x0000f007,SelectionChange,VT_EMPTY,VTS_NONE)
END_DISPATCH_MAP()

DWORD CEventSink::Advice(IUnknown *target,IUnknown *sink,REFIID iid)
{
	//
	// Sink for Events
	//
	LPCONNECTIONPOINTCONTAINER pConnPtCont;
	DWORD dwCokkie = 0;
	if ((target!= NULL) &&
		SUCCEEDED(target->QueryInterface(IID_IConnectionPointContainer,
			(LPVOID*)&pConnPtCont)))
	{
		ASSERT(pConnPtCont != NULL);
		LPCONNECTIONPOINT pConnPt = NULL;

		if (SUCCEEDED(pConnPtCont->FindConnectionPoint(iid, &pConnPt)))
		{
			ASSERT(pConnPt != NULL);
			pConnPt->Advise(sink, &dwCokkie);
			pConnPt->Release();
		}

		pConnPtCont->Release();
	}
	return dwCokkie;
}

void CEventSink::Unadvice(IUnknown *target,REFIID iid, DWORD dwCokkie)
{
	//
	// Sink for Events
	//
	LPCONNECTIONPOINTCONTAINER pConnPtCont;

	if ((target != NULL) &&
		SUCCEEDED(target->QueryInterface(IID_IConnectionPointContainer,
			(LPVOID*)&pConnPtCont)))
	{
		ASSERT(pConnPtCont != NULL);
		LPCONNECTIONPOINT pConnPt = NULL;

		if (SUCCEEDED(pConnPtCont->FindConnectionPoint(iid, &pConnPt)))
		{
			ASSERT(pConnPt != NULL);
			pConnPt->Unadvise(dwCokkie);
			pConnPt->Release();
		}

		pConnPtCont->Release();
	}
	return;
}


void CEventSink::Activate()
{
	if(m_inspector != 0) {
		Outlook::_MailItemPtr mailItem = m_inspector->CurrentItem;
		m_dlg.DisplayMailItem(mailItem); 
	}
	else {
		SelectionChange();
	}
}

void CEventSink::Deactivate()
{
}

void CEventSink::Close()
{
	if(m_inspector != 0) {
		Unadvice(m_inspector,__uuidof(Outlook::InspectorEvents),m_dwCokkie);
	}
	else {
		Unadvice(m_explorer,__uuidof(Outlook::ExplorerEvents),m_dwCokkie);
	}
	m_inspector = 0;
	this->GetIDispatch(FALSE)->Release();
}

void CEventSink::SelectionChange()
{
	long count = 0;
	if(m_explorer != 0) {
		Outlook::SelectionPtr& selection =m_explorer->Selection;
		if(selection->get_Count(&count) == S_OK && count > 0) {
			Outlook::_MailItemPtr mailItem = selection->Item((short)1);
			m_dlg.DisplayMailItem(mailItem); 
		}
	}
}
