// outlooksampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "outlooksample.h"
#include "outlooksampleDlg.h"
#include "DlgProxy.h"

#include "EventSink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COutlooksampleDlg dialog

IMPLEMENT_DYNAMIC(COutlooksampleDlg, CDialog);

COutlooksampleDlg::COutlooksampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COutlooksampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COutlooksampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
	EnableConnections();
	EnableAutomation();
}

COutlooksampleDlg::~COutlooksampleDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void COutlooksampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COutlooksampleDlg)
	DDX_Control(pDX, IDC_EDIT1, m_mail);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COutlooksampleDlg, CDialog)
	//{{AFX_MSG_MAP(COutlooksampleDlg)
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COutlooksampleDlg message handlers

BEGIN_DISPATCH_MAP(COutlooksampleDlg, CCmdTarget)
	DISP_FUNCTION_ID(COutlooksampleDlg, "NewInspector",0x0000f001,NewInspector,VT_EMPTY,VTS_DISPATCH)
END_DISPATCH_MAP()

BOOL COutlooksampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	CoInitialize(NULL);

	if(m_outlook == 0) {
		if(m_outlook.CreateInstance(__uuidof(Outlook::Application)) == S_OK) {
			Outlook::_InspectorsPtr inspectors; 
			if(m_outlook->get_Inspectors(&inspectors) == S_OK) {
				//use helper method to sink into 
				CEventSink::Advice(inspectors,GetIDispatch(FALSE), __uuidof(Outlook::InspectorsEvents));
			}
			new CEventSink(*this,m_outlook->ActiveExplorer());
		}
	}


	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COutlooksampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COutlooksampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void COutlooksampleDlg::OnClose() 
{
	if (CanExit())
		CDialog::OnClose();
}

void COutlooksampleDlg::OnOK() 
{
	if (CanExit())
		CDialog::OnOK();
}

void COutlooksampleDlg::OnCancel() 
{
	if (CanExit())
		CDialog::OnCancel();
}

BOOL COutlooksampleDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}


void COutlooksampleDlg::NewInspector(IDispatch *disp)
{
	new CEventSink(*this,disp);
}


void COutlooksampleDlg::DisplayMailItem(Outlook::_MailItemPtr& mailItem)
{
	if(IsWindow(*this)){
		CString data;
		if(mailItem != 0) {
			data = CString("Subject:\t\t") + (LPCTSTR)mailItem->Subject;
			//data += CString("\r\nFrom:\t\t") + (LPCTSTR)mailItem->SenderName ;
			//data += CString("\r\nTo:\t\t") + (LPCTSTR)mailItem->To;
			//data += CString("\r\nDate:\t\t") + (LPCTSTR)_bstr_t(mailItem->SentOn);
			data += CString("\r\nEntryID:\t\t") + (LPCTSTR)mailItem->EntryID;
			data += CString("\r\n\r\nBody:\r\n\t\t") + (LPCTSTR)mailItem->Body;
		}
		m_mail.SetWindowText(data);
	}
}

